// contact me at xeen.reversestudios.com if you need help understanding the functions
var autosizerProgressListener = {
	QueryInterface: function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		  aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		  aIID.equals(Components.interfaces.nsISupports))
		  return this;
		throw Components.results.NS_NOINTERFACE;
	},
	onProgressChange: function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
	onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
	onSecurityChange: function(aWebProgress, aRequest, aState) {},
	onLinkIconAvailable: function(a) {},
	onStateChange: function (aWebProgress, aRequest, aStateFlags, aStatus) {},
	onLocationChange: function(aProgress, aRequest, aLocation) { if (aLocation) autosizer.genWidthCheck(false); }
}

function AutosizerPrefObserver() {
	autosizer.checkPrefs(false);
}

AutosizerPrefObserver.prototype = {
  observe: function(subject, topic, pref) {
		if (topic == 'nsPref:changed') autosizer.checkPrefs(false);
	}
};

var autosizer = {
	init: function() {
		window.removeEventListener("load",function() { autosizer.init(); }, false);

		this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
		               .getService(Components.interfaces.nsIPrefBranch)
		               .getBranch('browser.search.searchbox.');
		this.initVar(); 
		
		this.txtOld=document.getElementById("searchbar").mTextbox;
		
		this.checkPrefs(true);
		if (this.useMacFix 
		     && (Components.classes['@mozilla.org/xre/app-info;1'])
		     && (Components.interfaces.nsIXULAppInfo) 
		     && (Components.interfaces.nsIXULRuntime))
		  this.sBox.setAttribute('platform',Components.classes['@mozilla.org/xre/app-info;1']
		    .getService(Components.interfaces.nsIXULAppInfo)
		    .QueryInterface(Components.interfaces.nsIXULRuntime).OS.toLowerCase());
		
   
		this.label.style.fontSize       = this.getStyle('font-size');
		this.label.style.fontSizeAdjust = this.getStyle('font-size-adjust');
		this.label.style.fontStretch    = this.getStyle('font-stretch');
		this.label.style.fontStyle      = this.getStyle('font-style');
		this.label.style.fontVariant    = this.getStyle('font-variant');
		this.label.style.fontWeight     = this.getStyle('font-weight');
		this.label.style.letterSpacing  = this.getStyle('letter-spacing');
		this.label.style.wordSpacing    = this.getStyle('word-spacing');

		window.addEventListener("load",function() { autosizer.genWidth(false); }, false);
		window.addEventListener("resize",function() { autosizer.genWidth(false); }, false);
		window.getBrowser().addProgressListener(autosizerProgressListener, Components.interfaces.nsIWebProgress.STATE_STOP);
		
	  if (this.prefs instanceof Components.interfaces.nsIPrefBranchInternal) {
			this.prefObserver = new AutosizerPrefObserver();
			this.prefs.addObserver('', this.prefObserver, false);
		}
		
		this.getAvailableWidth();
	}, 
	
	initVar: function() {
		this.txt=document.getElementById("searchbar").mTextbox;
		this.sBox = document.getElementById("search-container");
		this.label=document.getElementById('autosizer-label'); 		
		this.input=document.getAnonymousElementByAttribute(this.txt, "anonid", "input");
		this.diffWidth=(1+this.sBox.boxObject.width)-this.input.offsetWidth; 
		this.sBox.flex=0;
	},
	
	checkPrefs: function(startup) {
    this.useMacFix=this.prefs.getBoolPref('useMacFix');
    this.offset=this.prefs.getIntPref('offset');
	  this.minwidth=this.prefs.getIntPref('minwidth');
		this.maxwidth=this.prefs.getIntPref('maxwidth');
		this.cleanOnSubmit=this.prefs.getBoolPref('cleanOnSubmit');
		if(!startup) this.genWidth(false);
	},

	getStyle: function(aProperty) {
		return document.defaultView.getComputedStyle(this.input, '').getPropertyValue(aProperty);
	}, 
	
	getAvailableWidth: function() {
		var toolbaritems=this.sBox.parentNode.childNodes,flextemp,i,x;
		this.neededWidth=0;
		for(i=0;x=toolbaritems[i];i++) {
			if(x.id=='search-container') continue;
			flextemp=x.getAttribute('flex');
			x.setAttribute('flex',0);
			this.neededWidth+=toolbaritems[i].boxObject.width;
			x.setAttribute('flex',flextemp);
		}
	}, 	

	genWidth: function(evt) {
	  if(evt && evt.keyCode!=40 && evt.keyCode!=33 && evt.keyCode!=38 && evt.keyCode!=34 && this.txt.value.length>this.label.value.length+1) window.setTimeout("autosizer.focusEnd();",0); // on insertion fix - avoid if items were inserted by autocomplete	  
	  
		availableWidth=window.outerWidth-this.neededWidth;
    this.label.value=this.txt.value;  
    
	  var width=this.label.boxObject.width+this.diffWidth+this.offset;	
    
		if(width>this.maxwidth && this.maxwidth>0) width=this.maxwidth; // set max width 
		if(width<this.minwidth && this.minwidth>0) width=this.minwidth; // set min width
		if(width>availableWidth && availableWidth>0) width=availableWidth; // available width
		if(width<this.diffWidth) width=this.diffWidth+5; // needed width	
    autosizer.sBox.width=width;
		autosizer.sBox.style.maxWidth=width+'px';
	},
	
	focusEnd: function() { 		
		var oEvent = document.createEvent('KeyEvents');  
		oEvent.initKeyEvent("keypress",true,true,null,false,false,false,false,oEvent.DOM_VK_BACK_SPACE ,0);
		autosizer.txt.value+=' ';
	  autosizer.input.dispatchEvent(oEvent);
	},
   	

	genWidthCheck: function(evt) {
		this.initVar();     
		if(this.cleanOnSubmit && evt && evt.keyCode == 13) setTimeout("autosizer.txt.value='';autosizer.genWidth();",0); 
		if(this.txtOld!=this.txt) {
			this.txtOld=document.getElementById("searchbar").mTextbox;
			this.getAvailableWidth();
		}
		if(this.label.value!=this.txt.value) this.genWidth(evt);
	},

	d: function(t) {
    Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage('autosizer: '+t);
	}
}